# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rapid_pbd_msgs/ControlStrategy.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import moveit_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class ControlStrategy(genpy.Message):
  _md5sum = "c5dba7cf3e25163b1ab52069c4951b2f"
  _type = "rapid_pbd_msgs/ControlStrategy"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Position controller, avoids obstacles and moves at a fixed speed.
string DEFAULT_POSITION = default position
# Moves slower when close to obstacles, faster otherwise. Allows contact with obstacles.
string OBSTACLE_SLOWDOWN = obstacle slowdown
string type

float64 max_speed # Maximum speed of the end-effector in the default controller
float64 max_force # Stops the arm if detected contact force exceeds this threshold
moveit_msgs/OrientationConstraint orientation_constraint

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  # Pseudo-constants
  DEFAULT_POSITION = 'default position'
  OBSTACLE_SLOWDOWN = 'obstacle slowdown'

  __slots__ = ['type','max_speed','max_force','orientation_constraint']
  _slot_types = ['string','float64','float64','moveit_msgs/OrientationConstraint']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       type,max_speed,max_force,orientation_constraint

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ControlStrategy, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = ''
      if self.max_speed is None:
        self.max_speed = 0.
      if self.max_force is None:
        self.max_force = 0.
      if self.orientation_constraint is None:
        self.orientation_constraint = moveit_msgs.msg.OrientationConstraint()
    else:
      self.type = ''
      self.max_speed = 0.
      self.max_force = 0.
      self.orientation_constraint = moveit_msgs.msg.OrientationConstraint()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.max_speed, _x.max_force, _x.orientation_constraint.header.seq, _x.orientation_constraint.header.stamp.secs, _x.orientation_constraint.header.stamp.nsecs))
      _x = self.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.orientation_constraint.orientation.x, _x.orientation_constraint.orientation.y, _x.orientation_constraint.orientation.z, _x.orientation_constraint.orientation.w))
      _x = self.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.orientation_constraint.absolute_x_axis_tolerance, _x.orientation_constraint.absolute_y_axis_tolerance, _x.orientation_constraint.absolute_z_axis_tolerance, _x.orientation_constraint.weight))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.orientation_constraint is None:
        self.orientation_constraint = moveit_msgs.msg.OrientationConstraint()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.max_speed, _x.max_force, _x.orientation_constraint.header.seq, _x.orientation_constraint.header.stamp.secs, _x.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_constraint.orientation.x, _x.orientation_constraint.orientation.y, _x.orientation_constraint.orientation.z, _x.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_constraint.absolute_x_axis_tolerance, _x.orientation_constraint.absolute_y_axis_tolerance, _x.orientation_constraint.absolute_z_axis_tolerance, _x.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.max_speed, _x.max_force, _x.orientation_constraint.header.seq, _x.orientation_constraint.header.stamp.secs, _x.orientation_constraint.header.stamp.nsecs))
      _x = self.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.orientation_constraint.orientation.x, _x.orientation_constraint.orientation.y, _x.orientation_constraint.orientation.z, _x.orientation_constraint.orientation.w))
      _x = self.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.orientation_constraint.absolute_x_axis_tolerance, _x.orientation_constraint.absolute_y_axis_tolerance, _x.orientation_constraint.absolute_z_axis_tolerance, _x.orientation_constraint.weight))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.orientation_constraint is None:
        self.orientation_constraint = moveit_msgs.msg.OrientationConstraint()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.max_speed, _x.max_force, _x.orientation_constraint.header.seq, _x.orientation_constraint.header.stamp.secs, _x.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_constraint.orientation.x, _x.orientation_constraint.orientation.y, _x.orientation_constraint.orientation.z, _x.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_constraint.absolute_x_axis_tolerance, _x.orientation_constraint.absolute_y_axis_tolerance, _x.orientation_constraint.absolute_z_axis_tolerance, _x.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d3I = struct.Struct("<2d3I")
_struct_4d = struct.Struct("<4d")
