# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rapid_pbd_msgs/SegmentSurfacesResult.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg
import geometry_msgs.msg
import rapid_pbd_msgs.msg

class SegmentSurfacesResult(genpy.Message):
  _md5sum = "c80a7ce13151be47ffaee0afebce5029"
  _type = "rapid_pbd_msgs/SegmentSurfacesResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
rapid_pbd_msgs/Landmark[] landmarks
rapid_pbd_msgs/Surface surface
string cloud_db_id # MongoDB id of the cloud, if saved

================================================================================
MSG: rapid_pbd_msgs/Landmark
# Type of the landmark
# A TF frame ID
string TF_FRAME = tf frame
# A box from the tabletop object detector
string SURFACE_BOX = surface box
# A custom landmark
string CUSTOM_LANDMARK = custom landmark
# An AR tag or tag bundle
string AR_TAG = AR tag
string type

# Specifies the pose of the landmark.
# All landmarks and end-effector poses should be specified in the base frame so that
# an end-effector pose can always be transformed into the frame of a different landmark.
# This field can be blank if the landmark's pose is unknown at the time.
geometry_msgs/PoseStamped pose_stamped

# If type == TF_FRAME, name is the frame ID
# If type == SURFACE_BOX, name is an arbitrary name like "Object 1"
# If type == CUSTOM_LANDMARK, name is the name of the custom landmark
string name
geometry_msgs/Vector3 surface_box_dims # Dimensions of a tabletop box
uint32 ar_tag_id # The AR tag ID or master tag ID

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: rapid_pbd_msgs/Surface
# Represents a surface found when detecting surface objects.
geometry_msgs/PoseStamped pose_stamped # The pose of center of the table. Should be specified in the base frame.
geometry_msgs/Vector3 dimensions # Dimensions of the table, in meters
"""
  __slots__ = ['landmarks','surface','cloud_db_id']
  _slot_types = ['rapid_pbd_msgs/Landmark[]','rapid_pbd_msgs/Surface','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       landmarks,surface,cloud_db_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SegmentSurfacesResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.landmarks is None:
        self.landmarks = []
      if self.surface is None:
        self.surface = rapid_pbd_msgs.msg.Surface()
      if self.cloud_db_id is None:
        self.cloud_db_id = ''
    else:
      self.landmarks = []
      self.surface = rapid_pbd_msgs.msg.Surface()
      self.cloud_db_id = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.pose_stamped
        _v2 = _v1.header
        buff.write(_struct_I.pack(_v2.seq))
        _v3 = _v2.stamp
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v2.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v4 = _v1.pose
        _v5 = _v4.position
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = _v4.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v7 = val1.surface_box_dims
        _x = _v7
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_I.pack(val1.ar_tag_id))
      _x = self
      buff.write(_struct_3I.pack(_x.surface.pose_stamped.header.seq, _x.surface.pose_stamped.header.stamp.secs, _x.surface.pose_stamped.header.stamp.nsecs))
      _x = self.surface.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d.pack(_x.surface.pose_stamped.pose.position.x, _x.surface.pose_stamped.pose.position.y, _x.surface.pose_stamped.pose.position.z, _x.surface.pose_stamped.pose.orientation.x, _x.surface.pose_stamped.pose.orientation.y, _x.surface.pose_stamped.pose.orientation.z, _x.surface.pose_stamped.pose.orientation.w, _x.surface.dimensions.x, _x.surface.dimensions.y, _x.surface.dimensions.z))
      _x = self.cloud_db_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.landmarks is None:
        self.landmarks = None
      if self.surface is None:
        self.surface = rapid_pbd_msgs.msg.Surface()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = rapid_pbd_msgs.msg.Landmark()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v8 = val1.pose_stamped
        _v9 = _v8.header
        start = end
        end += 4
        (_v9.seq,) = _struct_I.unpack(str[start:end])
        _v10 = _v9.stamp
        _x = _v10
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v9.frame_id = str[start:end].decode('utf-8')
        else:
          _v9.frame_id = str[start:end]
        _v11 = _v8.pose
        _v12 = _v11.position
        _x = _v12
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v13 = _v11.orientation
        _x = _v13
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _v14 = val1.surface_box_dims
        _x = _v14
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (val1.ar_tag_id,) = _struct_I.unpack(str[start:end])
        self.landmarks.append(val1)
      _x = self
      start = end
      end += 12
      (_x.surface.pose_stamped.header.seq, _x.surface.pose_stamped.header.stamp.secs, _x.surface.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.surface.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.surface.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.surface.pose_stamped.pose.position.x, _x.surface.pose_stamped.pose.position.y, _x.surface.pose_stamped.pose.position.z, _x.surface.pose_stamped.pose.orientation.x, _x.surface.pose_stamped.pose.orientation.y, _x.surface.pose_stamped.pose.orientation.z, _x.surface.pose_stamped.pose.orientation.w, _x.surface.dimensions.x, _x.surface.dimensions.y, _x.surface.dimensions.z,) = _struct_10d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cloud_db_id = str[start:end].decode('utf-8')
      else:
        self.cloud_db_id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v15 = val1.pose_stamped
        _v16 = _v15.header
        buff.write(_struct_I.pack(_v16.seq))
        _v17 = _v16.stamp
        _x = _v17
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v16.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v18 = _v15.pose
        _v19 = _v18.position
        _x = _v19
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v20 = _v18.orientation
        _x = _v20
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v21 = val1.surface_box_dims
        _x = _v21
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_I.pack(val1.ar_tag_id))
      _x = self
      buff.write(_struct_3I.pack(_x.surface.pose_stamped.header.seq, _x.surface.pose_stamped.header.stamp.secs, _x.surface.pose_stamped.header.stamp.nsecs))
      _x = self.surface.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d.pack(_x.surface.pose_stamped.pose.position.x, _x.surface.pose_stamped.pose.position.y, _x.surface.pose_stamped.pose.position.z, _x.surface.pose_stamped.pose.orientation.x, _x.surface.pose_stamped.pose.orientation.y, _x.surface.pose_stamped.pose.orientation.z, _x.surface.pose_stamped.pose.orientation.w, _x.surface.dimensions.x, _x.surface.dimensions.y, _x.surface.dimensions.z))
      _x = self.cloud_db_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.landmarks is None:
        self.landmarks = None
      if self.surface is None:
        self.surface = rapid_pbd_msgs.msg.Surface()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = rapid_pbd_msgs.msg.Landmark()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v22 = val1.pose_stamped
        _v23 = _v22.header
        start = end
        end += 4
        (_v23.seq,) = _struct_I.unpack(str[start:end])
        _v24 = _v23.stamp
        _x = _v24
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v23.frame_id = str[start:end].decode('utf-8')
        else:
          _v23.frame_id = str[start:end]
        _v25 = _v22.pose
        _v26 = _v25.position
        _x = _v26
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v27 = _v25.orientation
        _x = _v27
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _v28 = val1.surface_box_dims
        _x = _v28
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (val1.ar_tag_id,) = _struct_I.unpack(str[start:end])
        self.landmarks.append(val1)
      _x = self
      start = end
      end += 12
      (_x.surface.pose_stamped.header.seq, _x.surface.pose_stamped.header.stamp.secs, _x.surface.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.surface.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.surface.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.surface.pose_stamped.pose.position.x, _x.surface.pose_stamped.pose.position.y, _x.surface.pose_stamped.pose.position.z, _x.surface.pose_stamped.pose.orientation.x, _x.surface.pose_stamped.pose.orientation.y, _x.surface.pose_stamped.pose.orientation.z, _x.surface.pose_stamped.pose.orientation.w, _x.surface.dimensions.x, _x.surface.dimensions.y, _x.surface.dimensions.z,) = _struct_10d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cloud_db_id = str[start:end].decode('utf-8')
      else:
        self.cloud_db_id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_10d = struct.Struct("<10d")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
